//
//  MP3Wrapper.h
//  ScreenMimic
//
//  Created by Lee Falin on 12/28/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "MP3Frame.h"

@interface MP3Wrapper : NSObject 
{
	NSMutableArray *frames;
	int totalFrames;
	NSString *mp3FileName;
}

#pragma mark FILE INIT
-(id)initWithRawFileName:(NSString*)fileName withSampleRate:(int)sampleRate andTotalSamples:(int)totalSamples;
-(id)initWithOtherFileName:(NSString*)fileName;
-(int)loadFramesFromFile:(NSString*)fileName;

#pragma mark ACCESSOR METHODS
-(NSString*)mp3FileName;
-(NSArray*)frames;
-(int)totalFrames;

#pragma mark ENUMERATOR
-(NSEnumerator*)frameEnumerator;

#pragma mark MP3 PARSING METHODS
-(void)convertRawAudioData:(NSString*)rawDataFileName toMPEGFile:(NSString*)fileName withTotalSamples:(int)totalSamples andSampleRate:(int)sampleRate;
-(BOOL)hasID3v2HeaderInData:(NSData*)data;


@end
