/* PreferencesController */

#import <Cocoa/Cocoa.h>
#import "ShortcutRecorder.h"

extern NSString *SMDefaultsFileStoragePath;
extern NSString *SMDefaultsRecordKeyCode;
extern NSString *SMDefaultsRecordKeyFlags;
extern NSString *SMDefaultsPauseKeyCode;
extern NSString *SMDefaultsPauseKeyFlags;
extern NSString *SMDefaultsQuietMode;

#define SMHotKeyRecord 1001
#define SMHotKeyPause 1002

// This has to be static. I don't like it, but it has to be.
NSMutableDictionary *registeredHotKeys;

@interface PreferencesController : NSWindowController
{
	IBOutlet ShortcutRecorder *recordShortcutField;
	NSWindow *mainWindow;
}

#pragma mark CLASS METHODS
+(NSMutableDictionary*)getRegisteredHotKeys;
+(int)idForHotKeyRef:(EventHotKeyRef)hkRef;

#pragma mark -
+(void)registerHotKeyWithCode:(unsigned int)keyCode andFlags:(unsigned int)flags forID:(int)keyId;
+(void)unregisterHotKeyforID:(int)keyId;

#pragma mark UI METHODS
-(IBAction)setTemporaryFileStorage:(id)sender;
-(void)sheetDidEnd:(NSSavePanel*)sheet returnCode:(int)returnCode contextInfo:(void*)contextInfo;

#pragma mark DELEGATE METHODS
-(void)shortcutRecorder:(ShortcutRecorder *)aRecorder keyComboDidChange:(short)keyCode withFlags:(unsigned int)flags;;

@end
